﻿using System;
using System.Windows.Forms;
using TextDetection.Common;
using TextDetection.Controls;

namespace TextDetection
{
    public partial class Form1 : Form
    {
        private PictureBoxControl _pictureBox;
        private readonly TextAreaFilter _textAreaFilter;
        public Form1()
        {
            InitializeComponent();
            _pictureBox = new PictureBoxControl(pictureBox);
            _textAreaFilter = new TextAreaFilter();
        }

        private void openImageToolStripMenuItem_Click(object sender, EventArgs e) =>
            new OpenFileDialog().OpenImage((imageFilePath)=>_pictureBox.OpenImage(imageFilePath,()=> detectTextToolStripMenuItem.Enabled = true));

        private void detectTextToolStripMenuItem_Click(object sender, EventArgs e)
        {
            new ImageProcessing(_pictureBox.Bitmap)
                .Grayscale()
                .DetectEdges((byte)nLow.Value, (byte)nHigh.Value, double.Parse(txtSigma.Text))
                .Dilate()
                .Binarize((int)nThreshold.Value)
                .HorizontalSmear((int)nHorizontalSmear.Value)
                .GetBlobs()
                .ForEach((rectangle) => _textAreaFilter.Filter(rectangle, _pictureBox.DrawRectangle));
        }
    }
}